
#ifndef SBW_TAP_H_
#define SBW_TAP_H_

#include <stdint.h>

// move to run-test/idle. typically this is done by sending a single TMS=0
// cycle, but the MSP430 has an extra JTAG fuse check that needs to be done
void sbw_tap_reset(void);
// more fuse checking stuff
void sbw_check_fuse(void);

// write IR contents. starts and ends in run-test/idle
uint8_t sbw_tap_shift_ir(uint8_t newir);
// read current IR contents. starts and ends in run-test/idle
//uint8_t sbw_tap_read_ir(void);

// write DR contents. starts and ends in run-test/idle
uint16_t sbw_tap_shift_dr(uint16_t newdr);
// read current DR contents. starts and ends in run-test/idle
static inline uint16_t sbw_tap_read_dr(void) { return sbw_tap_shift_dr(0x0000); }

#endif

