
#include <hardware/gpio.h>
#include <hardware/pio.h>
#include <hardware/timer.h>

#include "test.pio.h"

#define PIN_T2_OUT  2
#define PIN_T1_IN   3
#define PIN_T1_OUT  4
#define PIN_T1_SIDE 5

static volatile uint delay;

void piotest(void) {
	uint off1 = pio_add_program(pio0, &test1_program),
	     off2 = pio_add_program(pio0, &test2_program);

	float freq = 1/*0.05f*/ * 1000 * 1000;

	uint sm1 = 0, sm2 = 1;
	uint smmask = (1u << sm1) | (1u << sm2);

	test1_program_init(pio0, sm1, off1, PIN_T1_IN, PIN_T1_OUT, PIN_T1_SIDE, freq, false);
	test2_program_init(pio0, sm2, off2, PIN_T2_OUT, freq, false);

	delay = (uint)((0.85/*phase percentage*/ * 1000*1000/*microseconds*/) / freq);
	asm volatile("":::"memory"); // make sure delay is computed *before* enabling both SMs

	// reset and enable both at once
	pio_restart_sm_mask(pio0, smmask);

	pio_clkdiv_restart_sm_mask(pio0, smmask);

	//pio_sm_clkdiv_restart(pio0, sm2);
	///*busy_wait_us_32(0);*/busy_wait_us_32(delay);
	//pio_sm_clkdiv_restart(pio0, sm1);

	/*pio_sm_set_enabled(pio0, sm1, true);
	pio_sm_set_enabled(pio0, sm2, true);*/
	pio_set_sm_mask_enabled(pio0, smmask, true);

	while(1);
}

