
#ifndef ZAP_H_
#define ZAP_H_

#include "zap_pinout.h"

#include "zap_adc.h"
#include "zap_crowbar.h"
#include "zap_dac.h"
#include "zap_gpio.h"
#include "zap_max4619.h"
#include "zap_picoemp.h"

enum zap_component {
	zap_adc = 1,
	zap_crowbar = 2,
	zap_dac = 4,
	zap_gpio = 8,
	zap_max4619 = 16,
	zap_picoemp = 32
};

static inline void zap_init(enum zap_component zc) {
	if (zc & zap_adc) zap_adc_init();
	if (zc & zap_crowbar) zap_crowbar_init();
	if (zc & zap_dac) zap_dac_init(false);
	if (zc & zap_gpio) zap_gpio_init(false, true);
	if (zc & zap_max4619) zap_max_init(false, false);
	if (zc & zap_picoemp) zap_picoemp_init();
}
// TODO: deinit stuff (also in submodules)

static inline void zap_init_default(void) {
	zap_init(zap_adc | zap_crowbar | zap_dac | zap_gpio | zap_max4619);
}

#endif

