
#ifndef ZAP_ADC_H_
#define ZAP_ADC_H_

#include <stdint.h>

void zap_adc_init(void);

uint16_t zap_adc_read(int idx);

static inline uint16_t zap_adc_read_a(void) { return zap_adc_read(0); }
static inline uint16_t zap_adc_read_b(void) { return zap_adc_read(1); }

// returns Vbus value in 16.16 fixed-point format
//
// sadly uuuh in practice it's 'a bit' noisy, assuming Vbus = 5V is
// often more reliable than hand-tuning with this value, due to ADC
// inaccuracies, mismatch between R500 and R501, and so on...
//static inline uint32_t zap_adc_get_vbus(void) {
//	// Vbus value, 0x0fff = 3V3
//	// (ADC2 value is Vbus divided down by 2)
//	uint32_t vbus = (zap_adc_read(2) + 0x57/*hacky offset correction*/) * 2;
//
//	// shouldn't overflow
//	uint32_t vbusf = (vbus * (uint32_t)(3.3f * 0x10000)) / 0xfff;
//
//	return vbusf;
//}

#endif

