
#include "zap_crowbar.h"

void zap_crowbar_init(void) {
	const io_rw_32 pinmask = (1u << ZAP_CROWBAR_1) | (1u << ZAP_CROWBAR_2);

	sio_hw->gpio_clr = pinmask; // default to low -> hiZ by default
	sio_hw->gpio_oe_set = pinmask;

	gpio_set_slew_rate(ZAP_CROWBAR_1, GPIO_SLEW_RATE_FAST);
	gpio_set_slew_rate(ZAP_CROWBAR_2, GPIO_SLEW_RATE_FAST);
	gpio_set_drive_strength(ZAP_CROWBAR_1, GPIO_DRIVE_STRENGTH_12MA);
	gpio_set_drive_strength(ZAP_CROWBAR_2, GPIO_DRIVE_STRENGTH_12MA);

	gpio_set_function(ZAP_CROWBAR_1, GPIO_FUNC_SIO);
	gpio_set_function(ZAP_CROWBAR_2, GPIO_FUNC_SIO);
}

