
#ifndef ZAP_DAC_H_
#define ZAP_DAC_H_

#include <stdint.h>
#include <stdbool.h>

#include <hardware/gpio.h>

#include "zap_pinout.h"

enum zap_dac_ch {
	zap_dac_a = 1,
	zap_dac_b = 2
};

// "shdn": only relevant for MCP49x2
void zap_dac_init(bool shdn);

enum zap_dac_ch zap_dac_get_enable(void);
void zap_dac_set_enable(enum zap_dac_ch ch);
enum zap_dac_ch zap_dac_get_mulx2(void);
void zap_dac_set_mulx2(enum zap_dac_ch ch_x2);
uint16_t zap_dac_get_a(void);
uint16_t zap_dac_get_b(void);
void zap_dac_set_a(uint16_t a);
void zap_dac_set_b(uint16_t b);

// only relevant for MCP49x2
static inline void zap_dac_set_shutdown(bool shdn) {
	//gpio_put(ZAP_DAC_NSHDN, !shdn);
}

static inline void zap_dac_set(uint16_t a, uint16_t b) {
	zap_dac_set_a(a);
	zap_dac_set_b(b);
}

void zap_dac_latch(void);

#endif

