
#include <stdbool.h>

#include <hardware/structs/iobank0.h>
#include <hardware/gpio.h>

#include "zap_pinout.h"

#include "zap_max4619.h"

void zap_max_init(bool inhibit, bool use_jp300) {
	const io_rw_32 pinmask = 1u << ZAP_GLITCH_OUT;

	sio_hw->gpio_clr = pinmask; // default to low -> JP300
	sio_hw->gpio_oe_set = pinmask;

	gpio_set_slew_rate(ZAP_GLITCH_OUT, GPIO_SLEW_RATE_FAST);
	gpio_set_drive_strength(ZAP_GLITCH_OUT, GPIO_DRIVE_STRENGTH_12MA);
	gpio_set_function(ZAP_GLITCH_OUT, GPIO_FUNC_SIO);

	gpio_put(ZAP_MAX_VHI_SW, use_jp300);
	gpio_set_dir(ZAP_MAX_VHI_SW, GPIO_OUT);
	gpio_set_function(ZAP_MAX_VHI_SW, GPIO_FUNC_SIO);

	gpio_put(ZAP_MAX_INHIBIT, inhibit);
	gpio_set_dir(ZAP_MAX_INHIBIT, GPIO_OUT);
	gpio_set_function(ZAP_MAX_INHIBIT, GPIO_FUNC_SIO);
}


