
#ifndef ZAP_MAX4619_H_
#define ZAP_MAX4619_H_

#include <stdbool.h>

#include <hardware/structs/iobank0.h>

#include "zap_pinout.h"

void zap_max_init(bool inhibit, bool use_jp300);

static inline void zap_max_set_inhibit(bool inhibit) {
	if (inhibit) sio_hw->gpio_set = 1u << ZAP_MAX_INHIBIT;
	else sio_hw->gpio_clr = 1u << ZAP_MAX_INHIBIT;
}

static inline void zap_max_use_vhi_jp300(bool use_jp300 /* if false: use Vdac1 */) {
	if (use_jp300) sio_hw->gpio_set = 1u << ZAP_MAX_VHI_SW;
	else sio_hw->gpio_clr = 1u << ZAP_MAX_VHI_SW;
}

static inline void zap_max_put(bool low) {
	if (low) sio_hw->gpio_set = 1u << ZAP_GLITCH_OUT;
	else sio_hw->gpio_clr = 1u << ZAP_GLITCH_OUT;
}

#endif

